#! /usr/bin/env python

from __future__ import generators
__doc__ = """\
Project:    rPAS 
Version:    $Id: python.prov.py 29 2006-06-10 12:08:45Z ns $
Licence:    GPL
Start:      Mon Mar 15 00:52:16 MSK 2004
Title:      RPM Build Python  / Find Provides
Author:     
    Andrey Orlov (c) 2004
        
Description:     

    This application is intendent to extract provides for python packages.
    
Call:
    python_provides.py [<MODULE>]+

Switches:

    None

Warranty:

    There is no warranty of any kind, either expressed
    or implied
                        
TODO:
    Nothing

"""
__version__ = '$Revision: 1.1 $'[10:-1]
# $Id: python.prov.py 29 2006-06-10 12:08:45Z ns $
def _(s) : return s

def paths_from_pthfiles(prefix, buildroot, filenames):
        sitelibdirs = [os.path.join('usr', lib, prefix, 'site-packages')
                        for lib in ('lib', 'lib64')]
        for sitelibdir in sitelibdirs:
            build_slibdir = os.path.join(buildroot, sitelibdir)
            pth_files = [f for f in filenames 
                            if f.endswith(".pth") 
                            and dirname(f) == build_slibdir]
            for file in pth_files:
                    for line in open(file).readlines():
                            path = line.strip()
                            if path:
                                    yield os.path.join(sitelibdir, path)


try :
    import sys, os
    from os.path import basename, dirname
except :
    raise
else :    
    prefix = "python%u.%u" % sys.version_info[0:2]

    files = sys.argv[1:] or [ x.strip() for x in sys.stdin.readlines() ] 
    
    path = []
    buildroot = os.getenv('RPM_BUILD_ROOT',"")
    path.extend(paths_from_pthfiles(prefix, buildroot, files))

    path = tuple(sys.path[1:])+tuple(os.getenv('RPM_PYTHON_LIB_PATH','').split()) + tuple(path)

    pl = [] 
    init_d = dict(
        [(x,None) for x,y in [ os.path.split(x) for x in files ] if y == '__init__.py']
        + [ (os.path.normpath(buildroot + "/" + x),None) for x in os.getenv('RPM_PYTHON_MODULE_DECLARED','').split() ]
    )

    for module in os.getenv('RPM_PYTHON_MODULE_DECLARED','').split() :
        module = [ x for x in module.split("/") if x]
        for item in path :
            item = [ x for x in item.split("/") if x]
            if item == module[0:len(item)] :
                root = os.path.normpath(buildroot + "/" + os.path.join(*item))
                for parent in module[len(item):] :
                    root = os.path.join(root,parent)
                    if not init_d.has_key(root) :
                        break
                else :
                    pl.append( ( (".".join(module[len(item):]),) ,os.path.join(* ["/",buildroot]+module) ))

    path = [os.path.normpath(os.path.join( buildroot or '/', './'+x)) for x in path  ]

    sd = {}
    
    for src in files :
        if os.path.normpath(dirname(src)) in path :
            m,e = os.path.splitext( basename(src))
            if not '/' in m :
                print "%s(%s)" % (prefix,m)
                if e in ['.so'] :
                    if m[-6:] == "module" :
                        print "%s(%s)" % (prefix,m[0:-6])

        if basename(src) in ['__init__.py'] :
            if dirname(dirname(src)) in path :
                pl.append(((basename(dirname(src)),), dirname(src)) )
                print "%s(%s)" % (prefix,basename(dirname(src)))

        name,ext = os.path.splitext(basename(src))
        if ext in [".py"] :
            if name != "__init__":
                sd.setdefault(dirname(src),[]).append(name)
            else :
                sd.setdefault(dirname(dirname(src)),[]).append(basename(dirname(src)))


    while pl :
        m,p = pl.pop()

        try :
            pis = sd[p]
        except KeyError :
            pass
        else :
            for pi in pis :
                mo = m+(pi,)
                print "%s(%s)" % (prefix,".".join(mo))
                pl.insert(0,(mo, os.path.join(p,pi)))

# ex: set ts=8 sts=4 sw=4 et:
